<script lang="ts" setup>
import { computed, nextTick, onMounted, ref } from 'vue'
import type { VForm } from 'vuetify/components'
import { useMaterialStore } from '@/stores/material'
import { useTypeStore } from '@/stores/type'
import { useUnitStore } from '@/stores/unit'
import type { Material } from '@/types/Material'
const materialStore = useMaterialStore()
const headers = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Photo',
    key: 'image'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'Qty',
    key: 'qty',
    value: 'qty'
  },
  {
    title: 'Min',
    key: 'min',
    value: 'min'
  },
  {
    title: 'Unit',
    key: 'unit',
    value: (item: any | Material) => {
      if ('unit' in item && item.unit !== null && typeof item.unit === 'object') {
        return item.unit.name;
      }
      return "no Unit";
    }

  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const headers1 = [
  {
    title: 'Id',
    key: 'id',
    value: 'id'
  },
  {
    title: 'Name',
    key: 'name',
    value: 'name'
  },
  {
    title: 'QTY',
    key: 'qty',
    value: 'qty'
  }, {
    title: 'Min',
    key: 'min',
    value: 'min'

  },
  {
    title: 'Unit',
    key: 'unit',
    value: (item: any | Material) => {
      if ('unit' in item && item.unit !== null && typeof item.unit === 'object') {
        return item.unit.name;
      }
      return "no Unit";
    }
  }]

const unitStore = useUnitStore()
const material = ref<Material[]>([])
const lowStockItems = ref<Material[]>([])
const form = ref(false)
const refForm = ref<VForm | null>(null)
const dialog = ref(false)
const dialog1 = ref(false)
const dialogDelete = ref(false)
const loading = ref(false)


let editedIndex = -1
let lastId = 4

function onSubmit() { }

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    materialStore.clearForm()
  })
}
function checkStock() {
  const lowStockItems = materialStore.materials.filter(item => item.qty < item.min);

  console.log("Low Stock Items:", lowStockItems);

}
const filteredMaterial = computed(() => {
  return materialStore.materials.filter(item => item.qty < item.min);
});
async function deleteItemConfirm() {
  // Delete item from list
  await materialStore.deleteMaterial()
  closeDelete()
}
async function editItem(item: Material) {
  if (!item.id) return
  await materialStore.getMaterial(item.id)
  dialog.value = true
}
async function deleteItem(item: Material) {
  if (!item.id) return
  await materialStore.getMaterial(item.id)
  dialogDelete.value = true
  editedIndex = -1
}
function closeDialog() {
  dialog.value = false
  nextTick(() => {
    materialStore.clearForm()
  })
}
async function save() {
  const { valid } = await refForm.value!.validate()
  if (!valid) return
  await materialStore.saveMaterial()
  closeDialog()
}

onMounted(async () => {
  await materialStore.getMaterials()
  await unitStore.getUnits()
})
</script>

<template>
  <div>
    <v-data-table :headers="headers" :items="materialStore.materials" height="calc(90vh - 200px)" :sort-by="headers">
      <template v-slot:top>
        <v-toolbar flat style="background-color: rgb(97, 63, 45, 0.867)">
          <v-toolbar-title style="color: whitesmoke">Materials</v-toolbar-title>
          <v-divider class="mx-4" inset vertical></v-divider>
          <v-spacer></v-spacer>
          <!-- Put Edited Dialog -->

          <v-dialog v-model="dialog1" fullscreen :scrim="false" transition="dialog-bottom-transition">
            <template v-slot:activator="{ props }">
              <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4"
                color="black" dark v-bind="props" @click="materialStore.getAllsp()">
                Check Stock
              </v-btn>
            </template>
            <v-card>
              <v-toolbar dark color="brown">
                <v-btn icon dark @click="dialog1 = false">
                  <v-icon>mdi-close</v-icon>
                </v-btn>
                <v-toolbar-title>CheckStock</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-toolbar-items>
                  <v-btn style="background-color: rgba(35, 26, 15, 0.678); width: 150px; height: 60px" variant="text"
                    @click="dialog1 = false">
                    Save
                  </v-btn>
                </v-toolbar-items>
              </v-toolbar>
              <v-data-table :headers="headers1" :items="filteredMaterial"></v-data-table>
              <!-- เพิ่มข้อมูลตารางที่ต้องการแสดง -->
            </v-card>
          </v-dialog>

          <!-- new material -->
          <v-dialog v-model="dialog" persistent width="1024">
            <template v-slot:activator="{ props }">
              <v-btn style="color: whitesmoke" v-bind="props"> New Material </v-btn>
            </template>
            <v-card>
              <v-card-title>
                <span class="text-h5">Material Profile</span>
              </v-card-title>
              <v-card-text>
                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model="materialStore.editedMaterial.name" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Name"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model.number="materialStore.editedMaterial.qty" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Qty"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-text-field v-model.number="materialStore.editedMaterial.min" :readonly="loading"
                          :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                          label="Min"></v-text-field>
                      </v-col>
                      <v-col cols="12" sm="6">
                        <v-combobox v-model="materialStore.editedMaterial.unit" :items="unitStore.units"
                          item-title="name" item-value="id" label="Select unit" :return-object="true"></v-combobox>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-img :src="'http://localhost:3000/images/materials/' + materialStore.editedMaterial.image"
                          width="200"></v-img>
                      </v-col>
                      <v-col cols="12" sm="12" md="4">
                        <v-file-input v-model="materialStore.editedMaterial.files" :rules="[
                          (value) => {
                            return (
                              !value ||
                              !value.length ||
                              value[0].size < 2000000 ||
                              'Image size should be less than 2 MB!'
                            )
                          }
                        ]" accept="image/png, image/jpeg" label="Image" placeholder="Pick an image" prepend-icon="mdi-camera">
                        </v-file-input>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-form>
                <small>*indicates required field</small>
              </v-card-text>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDialog()"> Close </v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="save()"> Save </v-btn>
              </v-card-actions>
            </v-card>
          </v-dialog>

          <!-- Delete Dialog-->
          <v-dialog v-model="dialogDelete" max-width="500px">
            <v-card>
              <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
              <v-card-actions>
                <v-spacer></v-spacer>
                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                <v-spacer></v-spacer>
              </v-card-actions>
            </v-card>
          </v-dialog>
        </v-toolbar>
      </template>



      <template v-slot:[`item.actions`]="{ item }">
        <v-icon size="small" class="me-2" @click="editItem(item)"> mdi-pencil </v-icon>
        <v-icon size="small" @click="deleteItem(item)"> mdi-delete </v-icon>
      </template>

      <template v-slot:[`item.image`]="{ item }">
        <v-img :src="'http://localhost:3000/images/materials/' + item.image" width="100" style="height: 100px;"></v-img>
      </template>

      <template v-slot:no-data>
        <v-btn color="primary" @click="materialStore.getMaterials"> Reset </v-btn>
      </template>
    </v-data-table>
  </div>
</template>
